You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

86 lines
2.1 KiB

  1. #!/bin/sh
  2. set -e
  3. process_filespec() {
  4. local src_dir="$1"
  5. local dst_dir="$2"
  6. local filespec="$3"
  7. echo "$filespec" | (
  8. IFS='|'
  9. while read fop fspec fperm; do
  10. local fop=`echo "$fop" | tr -d ' \t\n'`
  11. if [ "$fop" = "+" ]; then
  12. if [ ! -e "${src_dir}${fspec}" ]; then
  13. echo "File not found '${src_dir}${fspec}'"
  14. exit 1
  15. fi
  16. dpath=`dirname "$fspec"`
  17. if [ -z "$fperm" ]; then
  18. dperm=`stat -c "%a" ${src_dir}${dpath}`
  19. fi
  20. mkdir -p -m$dperm ${dst_dir}${dpath}
  21. echo "copying: '$fspec'"
  22. cp -fpR ${src_dir}${fspec} ${dst_dir}${dpath}/
  23. if [ -n "$fperm" ]; then
  24. chmod -R $fperm ${dst_dir}${fspec}
  25. fi
  26. elif [ "$fop" = "-" ]; then
  27. echo "removing: '$fspec'"
  28. rm -fR ${dst_dir}${fspec}
  29. elif [ "$fop" = "=" ]; then
  30. echo "setting permissions: '$fperm' on '$fspec'"
  31. chmod -R $fperm ${dst_dir}${fspec}
  32. fi
  33. done
  34. )
  35. }
  36. ver="$1"
  37. src_dir="$2"
  38. dst_dir="$3"
  39. python="$4"
  40. mode="$5"
  41. filespec="$6"
  42. process_filespec "$src_dir" "$dst_dir" "$filespec" || {
  43. echo "process filespec error-ed"
  44. exit 1
  45. }
  46. if [ "$mode" == "sources" ] ; then
  47. # Copy only python source files
  48. find $dst_dir -not -type d -not -name "*\.py" | xargs rm -f
  49. # Delete empty folders (if the case)
  50. if [ -d "$dst_dir/usr" ] ; then
  51. find $dst_dir/usr -type d | xargs rmdir --ignore-fail-on-non-empty
  52. rmdir --ignore-fail-on-non-empty $dst_dir/usr
  53. fi
  54. exit 0
  55. fi
  56. legacy=
  57. [ "$ver" == "3" ] && legacy="-b"
  58. # XXX [So that you won't goof as I did]
  59. # Note: Yes, I tried to use the -O & -OO flags here.
  60. # However the generated byte-codes were not portable.
  61. # So, we just stuck to un-optimized byte-codes,
  62. # which is still way better/faster than running
  63. # Python sources all the time.
  64. $python -m compileall $legacy -d '/' $dst_dir || {
  65. echo "python -m compileall err-ed"
  66. exit 1
  67. }
  68. # Delete source files and pyc [ un-optimized bytecode files ]
  69. # We may want to make this optimization thing configurable later, but not sure atm
  70. find $dst_dir -type f -name "*\.py" | xargs rm -f
  71. # Delete empty folders (if the case)
  72. if [ -d "$dst_dir/usr" ] ; then
  73. find $dst_dir/usr -type d | xargs rmdir --ignore-fail-on-non-empty
  74. rmdir --ignore-fail-on-non-empty $dst_dir/usr
  75. fi
  76. exit 0